package org.jsxm.examples.Bank;

public class Account2{

    private int balance = 0;
    private boolean isOpen = false;
    private boolean isClosed = false;

    public void open() {
        if (!isClosed && !isOpen) {
            isOpen = true;
        } else
            throw new RuntimeException();
    }

    public void close() {
        if (!isClosed && isOpen && balance == 0) {
            isOpen = false;
            isClosed = true;
        } else
            throw new RuntimeException();
    }

    public void deposit(int x) {
        if (isOpen && x > 0) {
            balance += x;
        } else
            throw new RuntimeException();
    }

    public void withdraw(int x) {
        //Isn't it "balance != 0" redundant? if not why?
        if (isOpen && x>0 && balance != 0 && balance >= x) {
            balance -= x;
        } else
            throw new RuntimeException();
    }

}
